diff -ur ncurses-5.9-orig/ncurses/tinfo/setbuf.c ncurses-5.9/ncurses/tinfo/setbuf.c
--- ncurses-5.9-orig/ncurses/tinfo/setbuf.c	2010-08-28 17:08:31 -0400
+++ ncurses-5.9/ncurses/tinfo/setbuf.c	2013-07-04 18:38:38 -0400
@@ -149,8 +149,13 @@
 #ifdef SETVBUF_REVERSED		/* pre-svr3? */
 	(void) setvbuf(ofp, buf_ptr, buf_len, buf_len ? _IOFBF : _IOLBF);
 #else
+#ifdef _MSC_VER
+        /* MSVC does not accept 0 as buffer size */
+	(void) setvbuf(ofp, buf_ptr, buf_len ? _IOFBF : _IOLBF, buf_len ? buf_len : BUFSIZ);
+#else
 	(void) setvbuf(ofp, buf_ptr, buf_len ? _IOFBF : _IOLBF, buf_len);
 #endif
+#endif
 #elif HAVE_SETBUFFER
 	(void) setbuffer(ofp, buf_ptr, (int) buf_len);
 #endif
diff -ur ncurses-5.9-orig/ncurses/tinfo/write_entry.c ncurses-5.9/ncurses/tinfo/write_entry.c
--- ncurses-5.9-orig/ncurses/tinfo/write_entry.c	2010-12-25 18:23:08 -0500
+++ ncurses-5.9/ncurses/tinfo/write_entry.c	2013-07-04 18:38:38 -0400
@@ -173,7 +173,7 @@
 
 	if ((rc = stat(path, &statbuf)) < 0) {
 	    rc = mkdir(path
-#if !defined(__MINGW32__)
+#if !defined(__MINGW32__) && !defined(_MSC_VER)
 		       ,0777
 #endif
 		);
diff -ur ncurses-5.9-orig/ncurses/trace/lib_trace.c ncurses-5.9/ncurses/trace/lib_trace.c
--- ncurses-5.9-orig/ncurses/trace/lib_trace.c	2010-12-18 20:21:19 -0500
+++ ncurses-5.9/ncurses/trace/lib_trace.c	2013-07-04 18:38:38 -0400
@@ -121,7 +121,11 @@
 	 * end of each line.  This is useful in case the program dies. 
 	 */
 #if HAVE_SETVBUF		/* ANSI */
+#ifdef _MSC_VER
+	(void) setvbuf(TraceFP, (char *) 0, _IOLBF, BUFSIZ);
+#else
 	(void) setvbuf(TraceFP, (char *) 0, _IOLBF, 0);
+#endif
 #elif HAVE_SETBUF /* POSIX */
 	(void) setbuffer(TraceFP, (char *) 0);
 #endif
@@ -184,7 +188,7 @@
 # if USE_WEAK_SYMBOLS
 	if ((pthread_self))
 # endif
-#ifdef __MINGW32__
+#if defined(__MINGW32__) || defined(_MSC_VER)
 	    fprintf(TraceFP, "%#lx:", (long) (void *) pthread_self().p);
 #else
 	    fprintf(TraceFP, "%#lx:", (long) (void *) pthread_self());
diff -ur ncurses-5.9-orig/ncurses/tty/lib_twait.c ncurses-5.9/ncurses/tty/lib_twait.c
--- ncurses-5.9-orig/ncurses/tty/lib_twait.c	2010-12-25 18:43:58 -0500
+++ ncurses-5.9/ncurses/tty/lib_twait.c	2013-07-04 18:38:38 -0400
@@ -65,8 +65,12 @@
 #  include <sys/select.h>
 # endif
 #endif
-#ifdef __MINGW32__
-#  include <sys/time.h>
+#if defined(__MINGW32__) || defined(_MSC_VER)
+#  ifdef _MSC_VER
+#    include <winsock2.h>
+#  else
+#    include <sys/time.h>
+#  endif
 #endif
 #undef CUR
 
diff -ur ncurses-5.9-orig/ncurses/win32con/win_driver.c ncurses-5.9/ncurses/win32con/win_driver.c
--- ncurses-5.9-orig/ncurses/win32con/win_driver.c	2010-12-25 14:28:21 -0500
+++ ncurses-5.9/ncurses/win32con/win_driver.c	2013-07-04 18:38:38 -0400
@@ -138,7 +138,7 @@
 static BOOL
 con_write(TERMINAL_CONTROL_BLOCK * TCB, int y, int x, chtype *str, int n)
 {
-    CHAR_INFO ci[n];
+    CHAR_INFO* ci = (CHAR_INFO*)_alloca(n * sizeof(CHAR_INFO*));
     COORD loc, siz;
     SMALL_RECT rec;
     int i;
@@ -197,7 +197,7 @@
 
     if ((CurScreen(sp)->_clear || NewScreen(sp)->_clear)) {
 	int x;
-	chtype empty[Width];
+	chtype* empty = (chtype*)_alloca(Width * sizeof(chtype));
 
 	for (x = 0; x < Width; x++)
 	    empty[x] = ' ';
diff -ur ncurses-5.9-orig/panel/p_above.c ncurses-5.9/panel/p_above.c
--- ncurses-5.9-orig/panel/p_above.c	2010-01-23 16:22:15 -0500
+++ ncurses-5.9/panel/p_above.c	2013-07-04 18:38:38 -0400
@@ -39,7 +39,7 @@
 MODULE_ID("$Id: p_above.c,v 1.8 2010/01/23 21:22:15 tom Exp $")
 
 #if NCURSES_SP_FUNCS
-NCURSES_EXPORT(PANEL *)
+NCPANEL_EXPORT(PANEL *)
 ground_panel(SCREEN * sp)
 {
   T((T_CALLED("ground_panel(%p)"), sp));
@@ -62,7 +62,7 @@
 }
 #endif
 
-NCURSES_EXPORT(PANEL *)
+NCPANEL_EXPORT(PANEL *)
 panel_above(const PANEL * pan)
 {
   PANEL *result;
diff -ur ncurses-5.9-orig/panel/p_below.c ncurses-5.9/panel/p_below.c
--- ncurses-5.9-orig/panel/p_below.c	2010-01-23 16:22:15 -0500
+++ ncurses-5.9/panel/p_below.c	2013-07-04 18:38:38 -0400
@@ -39,7 +39,7 @@
 MODULE_ID("$Id: p_below.c,v 1.8 2010/01/23 21:22:15 tom Exp $")
 
 #if NCURSES_SP_FUNCS
-NCURSES_EXPORT(PANEL *)
+NCPANEL_EXPORT(PANEL *)
 ceiling_panel(SCREEN * sp)
 {
   T((T_CALLED("ceiling_panel(%p)"), sp));
@@ -60,7 +60,7 @@
 }
 #endif
 
-NCURSES_EXPORT(PANEL *)
+NCPANEL_EXPORT(PANEL *)
 panel_below(const PANEL * pan)
 {
   PANEL *result;
diff -ur ncurses-5.9-orig/panel/p_bottom.c ncurses-5.9/panel/p_bottom.c
--- ncurses-5.9-orig/panel/p_bottom.c	2010-01-23 16:22:16 -0500
+++ ncurses-5.9/panel/p_bottom.c	2013-07-04 18:38:38 -0400
@@ -39,7 +39,7 @@
 
 MODULE_ID("$Id: p_bottom.c,v 1.13 2010/01/23 21:22:16 tom Exp $")
 
-NCURSES_EXPORT(int)
+NCPANEL_EXPORT(int)
 bottom_panel(PANEL * pan)
 {
   int err = OK;
diff -ur ncurses-5.9-orig/panel/p_delete.c ncurses-5.9/panel/p_delete.c
--- ncurses-5.9-orig/panel/p_delete.c	2010-01-23 16:22:16 -0500
+++ ncurses-5.9/panel/p_delete.c	2013-07-04 18:38:38 -0400
@@ -39,7 +39,7 @@
 
 MODULE_ID("$Id: p_delete.c,v 1.10 2010/01/23 21:22:16 tom Exp $")
 
-NCURSES_EXPORT(int)
+NCPANEL_EXPORT(int)
 del_panel(PANEL * pan)
 {
   int err = OK;
diff -ur ncurses-5.9-orig/panel/p_hidden.c ncurses-5.9/panel/p_hidden.c
--- ncurses-5.9-orig/panel/p_hidden.c	2010-01-23 16:22:15 -0500
+++ ncurses-5.9/panel/p_hidden.c	2013-07-04 18:38:38 -0400
@@ -39,7 +39,7 @@
 
 MODULE_ID("$Id: p_hidden.c,v 1.9 2010/01/23 21:22:15 tom Exp $")
 
-NCURSES_EXPORT(int)
+NCPANEL_EXPORT(int)
 panel_hidden(const PANEL * pan)
 {
   int rc = ERR;
diff -ur ncurses-5.9-orig/panel/p_hide.c ncurses-5.9/panel/p_hide.c
--- ncurses-5.9-orig/panel/p_hide.c	2010-01-23 16:22:16 -0500
+++ ncurses-5.9/panel/p_hide.c	2013-07-04 18:38:38 -0400
@@ -38,7 +38,7 @@
 
 MODULE_ID("$Id: p_hide.c,v 1.11 2010/01/23 21:22:16 tom Exp $")
 
-NCURSES_EXPORT(int)
+NCPANEL_EXPORT(int)
 hide_panel(register PANEL * pan)
 {
   int err = ERR;
diff -ur ncurses-5.9-orig/panel/p_move.c ncurses-5.9/panel/p_move.c
--- ncurses-5.9-orig/panel/p_move.c	2010-01-23 16:22:15 -0500
+++ ncurses-5.9/panel/p_move.c	2013-07-04 18:38:38 -0400
@@ -39,7 +39,7 @@
 
 MODULE_ID("$Id: p_move.c,v 1.11 2010/01/23 21:22:15 tom Exp $")
 
-NCURSES_EXPORT(int)
+NCPANEL_EXPORT(int)
 move_panel(PANEL * pan, int starty, int startx)
 {
   int rc = ERR;
diff -ur ncurses-5.9-orig/panel/p_new.c ncurses-5.9/panel/p_new.c
--- ncurses-5.9-orig/panel/p_new.c	2010-01-23 16:22:16 -0500
+++ ncurses-5.9/panel/p_new.c	2013-07-04 18:38:38 -0400
@@ -88,7 +88,7 @@
   return _nc_stdscr_pseudo_panel;
 }
 
-NCURSES_EXPORT(PANEL *)
+NCPANEL_EXPORT(PANEL *)
 new_panel(WINDOW *win)
 {
   PANEL *pan = (PANEL *) 0;
diff -ur ncurses-5.9-orig/panel/p_replace.c ncurses-5.9/panel/p_replace.c
--- ncurses-5.9-orig/panel/p_replace.c	2010-01-23 16:22:16 -0500
+++ ncurses-5.9/panel/p_replace.c	2013-07-04 18:38:38 -0400
@@ -38,7 +38,7 @@
 
 MODULE_ID("$Id: p_replace.c,v 1.11 2010/01/23 21:22:16 tom Exp $")
 
-NCURSES_EXPORT(int)
+NCPANEL_EXPORT(int)
 replace_panel(PANEL * pan, WINDOW *win)
 {
   int rc = ERR;
diff -ur ncurses-5.9-orig/panel/p_show.c ncurses-5.9/panel/p_show.c
--- ncurses-5.9-orig/panel/p_show.c	2010-01-23 16:22:16 -0500
+++ ncurses-5.9/panel/p_show.c	2013-07-04 18:38:38 -0400
@@ -38,7 +38,7 @@
 
 MODULE_ID("$Id: p_show.c,v 1.13 2010/01/23 21:22:16 tom Exp $")
 
-NCURSES_EXPORT(int)
+NCPANEL_EXPORT(int)
 show_panel(PANEL * pan)
 {
   int err = ERR;
diff -ur ncurses-5.9-orig/panel/p_top.c ncurses-5.9/panel/p_top.c
--- ncurses-5.9-orig/panel/p_top.c	2010-01-23 16:22:16 -0500
+++ ncurses-5.9/panel/p_top.c	2013-07-04 18:38:39 -0400
@@ -38,7 +38,7 @@
 
 MODULE_ID("$Id: p_top.c,v 1.6 2010/01/23 21:22:16 tom Exp $")
 
-NCURSES_EXPORT(int)
+NCPANEL_EXPORT(int)
 top_panel(PANEL * pan)
 {
   T((T_CALLED("top_panel(%p)"), (void *)pan));
diff -ur ncurses-5.9-orig/panel/p_update.c ncurses-5.9/panel/p_update.c
--- ncurses-5.9-orig/panel/p_update.c	2010-01-23 16:22:16 -0500
+++ ncurses-5.9/panel/p_update.c	2013-07-04 18:38:39 -0400
@@ -39,7 +39,7 @@
 
 MODULE_ID("$Id: p_update.c,v 1.11 2010/01/23 21:22:16 tom Exp $")
 
-NCURSES_EXPORT(void)
+NCPANEL_EXPORT(void)
 NCURSES_SP_NAME(update_panels) (NCURSES_SP_DCL0)
 {
   PANEL *pan;
@@ -70,7 +70,7 @@
 }
 
 #if NCURSES_SP_FUNCS
-NCURSES_EXPORT(void)
+NCPANEL_EXPORT(void)
 update_panels(void)
 {
   NCURSES_SP_NAME(update_panels) (CURRENT_SCREEN);
diff -ur ncurses-5.9-orig/panel/p_user.c ncurses-5.9/panel/p_user.c
--- ncurses-5.9-orig/panel/p_user.c	2010-01-23 18:18:35 -0500
+++ ncurses-5.9/panel/p_user.c	2013-07-04 18:38:39 -0400
@@ -38,7 +38,7 @@
 
 MODULE_ID("$Id: p_user.c,v 1.8 2010/01/23 23:18:35 tom Exp $")
 
-NCURSES_EXPORT(int)
+NCPANEL_EXPORT(int)
 set_panel_userptr(PANEL * pan, NCURSES_CONST void *uptr)
 {
   T((T_CALLED("set_panel_userptr(%p,%p)"), (void *)pan, (NCURSES_CONST void *)uptr));
@@ -48,7 +48,7 @@
   returnCode(OK);
 }
 
-NCURSES_EXPORT(NCURSES_CONST void *)
+NCPANEL_EXPORT(NCURSES_CONST void *)
 panel_userptr(const PANEL * pan)
 {
   T((T_CALLED("panel_userptr(%p)"), (const void *)pan));
diff -ur ncurses-5.9-orig/panel/p_win.c ncurses-5.9/panel/p_win.c
--- ncurses-5.9-orig/panel/p_win.c	2010-01-23 16:22:15 -0500
+++ ncurses-5.9/panel/p_win.c	2013-07-04 18:38:39 -0400
@@ -38,7 +38,7 @@
 
 MODULE_ID("$Id: p_win.c,v 1.6 2010/01/23 21:22:15 tom Exp $")
 
-NCURSES_EXPORT(WINDOW *)
+NCPANEL_EXPORT(WINDOW *)
 panel_window(const PANEL * pan)
 {
   T((T_CALLED("panel_window(%p)"), (const void *)pan));
diff -ur ncurses-5.9-orig/panel/panel.c ncurses-5.9/panel/panel.c
--- ncurses-5.9-orig/panel/panel.c	2010-01-23 16:22:16 -0500
+++ ncurses-5.9/panel/panel.c	2013-07-04 18:38:39 -0400
@@ -42,7 +42,7 @@
 	_nc_retrace_panel (pan)
 --------------------------------------------------------------------------*/
 #ifdef TRACE
-NCURSES_EXPORT(PANEL *)
+NCPANEL_EXPORT(PANEL *)
 _nc_retrace_panel(PANEL * pan)
 {
   T((T_RETURN("%p"), (void *)pan));
@@ -55,7 +55,7 @@
 --------------------------------------------------------------------------*/
 #ifdef TRACE
 #ifndef TRACE_TXT
-NCURSES_EXPORT(const char *)
+NCPANEL_EXPORT(const char *)
 _nc_my_visbuf(const void *ptr)
 {
   char temp[32];
@@ -73,7 +73,7 @@
 	dPanel(text,pan)
 --------------------------------------------------------------------------*/
 #ifdef TRACE
-NCURSES_EXPORT(void)
+NCPANEL_EXPORT(void)
 _nc_dPanel(const char *text, const PANEL * pan)
 {
   _tracef("%s id=%s b=%s a=%s y=%d x=%d",
@@ -88,7 +88,7 @@
 	dStack(fmt,num,pan)
 --------------------------------------------------------------------------*/
 #ifdef TRACE
-NCURSES_EXPORT(void)
+NCPANEL_EXPORT(void)
 _nc_dStack(const char *fmt, int num, const PANEL * pan)
 {
   char s80[80];
@@ -114,7 +114,7 @@
 	Wnoutrefresh(pan) - debugging hook for wnoutrefresh
 --------------------------------------------------------------------------*/
 #ifdef TRACE
-NCURSES_EXPORT(void)
+NCPANEL_EXPORT(void)
 _nc_Wnoutrefresh(const PANEL * pan)
 {
   dPanel("wnoutrefresh", pan);
@@ -126,7 +126,7 @@
 	Touchpan(pan)
 --------------------------------------------------------------------------*/
 #ifdef TRACE
-NCURSES_EXPORT(void)
+NCPANEL_EXPORT(void)
 _nc_Touchpan(const PANEL * pan)
 {
   dPanel("Touchpan", pan);
@@ -138,7 +138,7 @@
 	Touchline(pan,start,count)
 --------------------------------------------------------------------------*/
 #ifdef TRACE
-NCURSES_EXPORT(void)
+NCPANEL_EXPORT(void)
 _nc_Touchline(const PANEL * pan, int start, int count)
 {
   char s80[80];
diff -ur ncurses-5.9-orig/panel/panel.h ncurses-5.9/panel/panel.h
--- ncurses-5.9-orig/panel/panel.h	2009-04-11 15:50:40 -0400
+++ ncurses-5.9/panel/panel.h	2013-07-04 18:38:39 -0400
@@ -53,27 +53,27 @@
 extern "C" {
 #endif
 
-extern NCURSES_EXPORT(WINDOW*) panel_window (const PANEL *);
-extern NCURSES_EXPORT(void)    update_panels (void);
-extern NCURSES_EXPORT(int)     hide_panel (PANEL *);
-extern NCURSES_EXPORT(int)     show_panel (PANEL *);
-extern NCURSES_EXPORT(int)     del_panel (PANEL *);
-extern NCURSES_EXPORT(int)     top_panel (PANEL *);
-extern NCURSES_EXPORT(int)     bottom_panel (PANEL *);
-extern NCURSES_EXPORT(PANEL*)  new_panel (WINDOW *);
-extern NCURSES_EXPORT(PANEL*)  panel_above (const PANEL *);
-extern NCURSES_EXPORT(PANEL*)  panel_below (const PANEL *);
-extern NCURSES_EXPORT(int)     set_panel_userptr (PANEL *, NCURSES_CONST void *);
-extern NCURSES_EXPORT(NCURSES_CONST void*) panel_userptr (const PANEL *);
-extern NCURSES_EXPORT(int)     move_panel (PANEL *, int, int);
-extern NCURSES_EXPORT(int)     replace_panel (PANEL *,WINDOW *);
-extern NCURSES_EXPORT(int)     panel_hidden (const PANEL *);
+extern NCPANEL_EXPORT(WINDOW*) panel_window (const PANEL *);
+extern NCPANEL_EXPORT(void)    update_panels (void);
+extern NCPANEL_EXPORT(int)     hide_panel (PANEL *);
+extern NCPANEL_EXPORT(int)     show_panel (PANEL *);
+extern NCPANEL_EXPORT(int)     del_panel (PANEL *);
+extern NCPANEL_EXPORT(int)     top_panel (PANEL *);
+extern NCPANEL_EXPORT(int)     bottom_panel (PANEL *);
+extern NCPANEL_EXPORT(PANEL*)  new_panel (WINDOW *);
+extern NCPANEL_EXPORT(PANEL*)  panel_above (const PANEL *);
+extern NCPANEL_EXPORT(PANEL*)  panel_below (const PANEL *);
+extern NCPANEL_EXPORT(int)     set_panel_userptr (PANEL *, NCURSES_CONST void *);
+extern NCPANEL_EXPORT(NCURSES_CONST void*) panel_userptr (const PANEL *);
+extern NCPANEL_EXPORT(int)     move_panel (PANEL *, int, int);
+extern NCPANEL_EXPORT(int)     replace_panel (PANEL *,WINDOW *);
+extern NCPANEL_EXPORT(int)     panel_hidden (const PANEL *);
 
 #if NCURSES_SP_FUNCS
-extern NCURSES_EXPORT(PANEL *) ground_panel(SCREEN *);
-extern NCURSES_EXPORT(PANEL *) ceiling_panel(SCREEN *);
+extern NCPANEL_EXPORT(PANEL *) ground_panel(SCREEN *);
+extern NCPANEL_EXPORT(PANEL *) ceiling_panel(SCREEN *);
 
-extern NCURSES_EXPORT(void)    NCURSES_SP_NAME(update_panels) (SCREEN*);
+extern NCPANEL_EXPORT(void)    NCURSES_SP_NAME(update_panels) (SCREEN*);
 #endif
 
 #if	defined(__cplusplus)
diff -ur ncurses-5.9-orig/panel/panel.priv.h ncurses-5.9/panel/panel.priv.h
--- ncurses-5.9-orig/panel/panel.priv.h	2009-04-11 16:33:55 -0400
+++ ncurses-5.9/panel/panel.priv.h	2013-07-04 18:38:39 -0400
@@ -53,7 +53,7 @@
 
 
 #ifdef TRACE
-   extern NCURSES_EXPORT(const char *) _nc_my_visbuf (const void *);
+   extern NCPANEL_EXPORT(const char *) _nc_my_visbuf (const void *);
 #  ifdef TRACE_TXT
 #    define USER_PTR(ptr) _nc_visbuf((const char *)ptr)
 #  else
@@ -62,12 +62,12 @@
 
 #  define returnPanel(code)	TRACE_RETURN(code,panel)
 
-   extern NCURSES_EXPORT(PANEL *) _nc_retrace_panel (PANEL *);
-   extern NCURSES_EXPORT(void) _nc_dPanel (const char*, const PANEL*);
-   extern NCURSES_EXPORT(void) _nc_dStack (const char*, int, const PANEL*);
-   extern NCURSES_EXPORT(void) _nc_Wnoutrefresh (const PANEL*);
-   extern NCURSES_EXPORT(void) _nc_Touchpan (const PANEL*);
-   extern NCURSES_EXPORT(void) _nc_Touchline (const PANEL*, int, int);
+   extern NCPANEL_EXPORT(PANEL *) _nc_retrace_panel (PANEL *);
+   extern NCPANEL_EXPORT(void) _nc_dPanel (const char*, const PANEL*);
+   extern NCPANEL_EXPORT(void) _nc_dStack (const char*, int, const PANEL*);
+   extern NCPANEL_EXPORT(void) _nc_Wnoutrefresh (const PANEL*);
+   extern NCPANEL_EXPORT(void) _nc_Touchpan (const PANEL*);
+   extern NCPANEL_EXPORT(void) _nc_Touchline (const PANEL*, int, int);
 
 #  define dBug(x) _tracef x
 #  define dPanel(text,pan) _nc_dPanel(text,pan)
@@ -208,7 +208,7 @@
 
 #if NCURSES_SP_FUNCS
 /* These may become later renamed and part of panel.h and the public API */
-extern NCURSES_EXPORT(void) NCURSES_SP_NAME(_nc_update_panels)(SCREEN*);
+extern NCPANEL_EXPORT(void) NCURSES_SP_NAME(_nc_update_panels)(SCREEN*);
 #endif
 
 #endif /* NCURSES_PANEL_PRIV_H */
diff -ur ncurses-5.9-orig/progs/progs.priv.h ncurses-5.9/progs/progs.priv.h
--- ncurses-5.9-orig/progs/progs.priv.h	2008-08-03 13:43:05 -0400
+++ ncurses-5.9/progs/progs.priv.h	2013-07-04 18:38:39 -0400
@@ -148,8 +148,14 @@
 #endif
 
 #ifndef X_OK
+#ifdef _MSC_VER
+#define X_OK    0		/* MSVC does not support X_OK and generate invalid
+                                 * parameter exception if used as argument to "access"
+                                 * function. */
+#else
 #define	X_OK	1		/* Test for executable.  */
 #endif
+#endif
 
 #ifndef F_OK
 #define	F_OK	0		/* Test for existence.  */
diff -ur ncurses-5.9-orig/test/dots.c ncurses-5.9/test/dots.c
--- ncurses-5.9-orig/test/dots.c	2010-11-13 20:00:02 -0500
+++ ncurses-5.9/test/dots.c	2013-07-04 18:38:39 -0400
@@ -42,6 +42,10 @@
 
 #define valid(s) ((s != 0) && s != (char *)-1)
 
+#ifdef _MSC_VER
+#  define STDOUT_FILENO 1
+#endif
+
 static bool interrupted = FALSE;
 static long total_chars = 0;
 static time_t started;
diff -ur ncurses-5.9-orig/test/dots_mvcur.c ncurses-5.9/test/dots_mvcur.c
--- ncurses-5.9-orig/test/dots_mvcur.c	2010-11-13 20:00:44 -0500
+++ ncurses-5.9/test/dots_mvcur.c	2013-07-04 18:38:39 -0400
@@ -42,6 +42,10 @@
 
 #define valid(s) ((s != 0) && s != (char *)-1)
 
+#ifdef _MSC_VER
+#  define STDOUT_FILENO 1
+#endif
+
 static bool interrupted = FALSE;
 static long total_chars = 0;
 static time_t started;
diff -ur ncurses-5.9-orig/test/ncurses.c ncurses-5.9/test/ncurses.c
--- ncurses-5.9-orig/test/ncurses.c	2011-01-22 14:48:33 -0500
+++ ncurses-5.9/test/ncurses.c	2013-07-04 18:38:39 -0400
@@ -487,7 +487,7 @@
 	addstr("Shelling out...");
     def_prog_mode();
     endwin();
-#ifdef __MINGW32__
+#if defined(__MINGW32__) || defined(_MSC_VER)
     system("cmd.exe");
 #else
     system("sh");
diff -ur ncurses-5.9-orig/test/railroad.c ncurses-5.9/test/railroad.c
--- ncurses-5.9-orig/test/railroad.c	2009-10-24 17:37:56 -0400
+++ ncurses-5.9/test/railroad.c	2013-07-04 18:38:39 -0400
@@ -36,6 +36,10 @@
 #define USE_TINFO
 #include <test.priv.h>
 
+#ifdef _MSC_VER
+#  define STDOUT_FILENO 1
+#endif
+
 #if HAVE_TGETENT
 
 static char *wipeit;
diff -ur ncurses-5.9-orig/test/rain.c ncurses-5.9/test/rain.c
--- ncurses-5.9-orig/test/rain.c	2010-11-13 15:11:46 -0500
+++ ncurses-5.9/test/rain.c	2013-07-04 18:38:39 -0400
@@ -222,7 +222,7 @@
      * Find myself in the list of threads so we can count the number of loops.
      */
     for (mystats = 0; mystats < MAX_THREADS; ++mystats) {
-#ifdef __MINGW32__
+#if defined(__MINGW32__) || defined(_MSC_VER)
 	if (drop_threads[mystats].myself.p == pthread_self().p)
 #else
 	if (drop_threads[mystats].myself == pthread_self())
diff -ur ncurses-5.9-orig/test/test.priv.h ncurses-5.9/test/test.priv.h
--- ncurses-5.9-orig/test/test.priv.h	2011-03-22 05:15:45 -0400
+++ ncurses-5.9/test/test.priv.h	2013-07-04 18:38:39 -0400
@@ -609,7 +609,7 @@
 #define EXIT_FAILURE 1
 #endif
 
-#ifdef __MINGW32__
+#if defined(__MINGW32__) || defined(_MSC_VER)
 #include <nc_mingw.h>
 /* conflicts in test/firstlast.c */
 #undef large
@@ -641,12 +641,24 @@
 
 #define VT_ACSC "``aaffggiijjkkllmmnnooppqqrrssttuuvvwwxxyyzz{{||}}~~"
 
+#ifdef _MSC_VER
+#define CATCHALL(handler) \
+	do { \
+		/* These are the only signal allowed by MSVC. */ \
+		signal(SIGINT, handler); \
+		signal(SIGILL, handler); \
+		signal(SIGFPE, handler); \
+		signal(SIGSEGV, handler); \
+		signal(SIGABRT, handler); \
+        } while (0)
+#else
 #define CATCHALL(handler) { \
 		int nsig; \
 		for (nsig = SIGHUP; nsig < SIGTERM; ++nsig) \
 		    if (nsig != SIGKILL) \
 			signal(nsig, handler); \
 	    }
+#endif
 
 /*
  * Workaround for clean(er) compile with Solaris's legacy curses.
diff -ur ncurses-5.9-orig/test/view.c ncurses-5.9/test/view.c
--- ncurses-5.9-orig/test/view.c	2010-11-13 20:06:02 -0500
+++ ncurses-5.9/test/view.c	2013-07-04 18:38:39 -0400
@@ -62,7 +62,7 @@
 #if HAVE_TERMIOS_H
 # include <termios.h>
 #else
-#if !defined(__MINGW32__)
+#if !defined(__MINGW32__) && !defined(_MSC_VER)
 # include <sgtty.h>
 #endif
 #endif
